<!DOCTYPE HTML>
<!-- NewPage -->
<html lang="en">
<head>
<!-- Generated by javadoc (14.0.1) on Wed Aug 25 22:08:27 CEST 2021 -->
<title>GrindspotController</title>
<meta http-equiv="Content-Type" content="text/html; charset=utf-8">
<meta name="dc.created" content="2021-08-25">
<meta name="description" content="declaration: package: com.zelyvanna.bdoefficiency.controller, class: GrindspotController">
<meta name="generator" content="javadoc/ClassWriterImpl">
<link rel="stylesheet" type="text/css" href="../../../../stylesheet.css" title="Style">
<link rel="stylesheet" type="text/css" href="../../../../script-dir/jquery-ui.css" title="Style">
<script type="text/javascript" src="../../../../script.js"></script>
<script type="text/javascript" src="../../../../script-dir/jszip/dist/jszip.min.js"></script>
<script type="text/javascript" src="../../../../script-dir/jszip-utils/dist/jszip-utils.min.js"></script>
<!--[if IE]>
<script type="text/javascript" src="../../../../script-dir/jszip-utils/dist/jszip-utils-ie.min.js"></script>
<![endif]-->
<script type="text/javascript" src="../../../../script-dir/jquery-3.4.1.js"></script>
<script type="text/javascript" src="../../../../script-dir/jquery-ui.js"></script>
</head>
<body class="class-declaration">
<script type="text/javascript">var data = {"i0":10,"i1":10,"i2":10,"i3":10,"i4":10};
var tabs = {65535:["t0","All Methods"],2:["t2","Instance Methods"],8:["t4","Concrete Methods"]};
var altColor = "altColor";
var rowColor = "rowColor";
var tableTab = "tableTab";
var activeTableTab = "activeTableTab";
var pathtoroot = "../../../../";
loadScripts(document, 'script');</script>
<noscript>
<div>JavaScript is disabled on your browser.</div>
</noscript>
<div class="flexBox">
<header role="banner" class="flexHeader">
<nav role="navigation">
<!-- ========= START OF TOP NAVBAR ======= -->
<div class="topNav"><a id="navbar.top">
<!--   -->
</a>
<div class="skipNav"><a href="#skip.navbar.top" title="Skip navigation links">Skip navigation links</a></div>
<a id="navbar.top.firstrow">
<!--   -->
</a>
<ul class="navList" title="Navigation">
<li><a href="../../../../index.html">Overview</a></li>
<li><a href="package-summary.html">Package</a></li>
<li class="navBarCell1Rev">Class</li>
<li><a href="package-tree.html">Tree</a></li>
<li><a href="../../../../deprecated-list.html">Deprecated</a></li>
<li><a href="../../../../index-files/index-1.html">Index</a></li>
<li><a href="../../../../help-doc.html">Help</a></li>
</ul>
</div>
<div class="subNav">
<div>
<ul class="subNavList">
<li>Summary:&nbsp;</li>
<li>Nested&nbsp;|&nbsp;</li>
<li><a href="#field.summary">Field</a>&nbsp;|&nbsp;</li>
<li><a href="#constructor.summary">Constr</a>&nbsp;|&nbsp;</li>
<li><a href="#method.summary">Method</a></li>
</ul>
<ul class="subNavList">
<li>Detail:&nbsp;</li>
<li><a href="#field.detail">Field</a>&nbsp;|&nbsp;</li>
<li><a href="#constructor.detail">Constr</a>&nbsp;|&nbsp;</li>
<li><a href="#method.detail">Method</a></li>
</ul>
</div>
<div class="navListSearch"><label for="search">SEARCH:</label>
<input type="text" id="search" value="search" disabled="disabled">
<input type="reset" id="reset" value="reset" disabled="disabled">
</div>
</div>
<!-- ========= END OF TOP NAVBAR ========= -->
<div class="skipNav"><a id="skip.navbar.top">
<!--   -->
</a></div>
</nav>
</header>
<div class="flexContent">
<main role="main">
<!-- ======== START OF CLASS DATA ======== -->
<div class="header">
<div class="subTitle"><span class="packageLabelInType">Package</span>&nbsp;<a href="package-summary.html">com.zelyvanna.bdoefficiency.controller</a></div>
<h1 title="Class GrindspotController" class="title">Class GrindspotController</h1>
</div>
<div class="contentContainer">
<div class="inheritance" title="Inheritance Tree">java.lang.Object
<div class="inheritance">com.zelyvanna.bdoefficiency.controller.GrindspotController</div>
</div>
<section class="description">
<hr>
<pre>@CrossOrigin(origins="*")
@RestController
@RequestMapping("/api")
public class <span class="typeNameLabel">GrindspotController</span>
extends java.lang.Object</pre>
<div class="block">Grindspot Controller</div>
</section>
<section class="summary">
<ul class="blockList">
<!-- =========== FIELD SUMMARY =========== -->
<li class="blockList">
<section class="fieldSummary"><a id="field.summary">
<!--   -->
</a>
<h2>Field Summary</h2>
<div class="memberSummary">
<table>
<caption><span>Fields</span><span class="tabEnd">&nbsp;</span></caption>
<thead>
<tr>
<th class="colFirst" scope="col">Modifier and Type</th>
<th class="colSecond" scope="col">Field</th>
<th class="colLast" scope="col">Description</th>
</tr>
</thead>
<tbody>
<tr class="altColor">
<td class="colFirst"><code>(package private) <a href="../repository/GrindspotRepository.html" title="interface in com.zelyvanna.bdoefficiency.repository">GrindspotRepository</a></code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#grindspotRepository">grindspotRepository</a></span></code></th>
<td class="colLast">&nbsp;</td>
</tr>
</tbody>
</table>
</div>
</section>
</li>
<!-- ======== CONSTRUCTOR SUMMARY ======== -->
<li class="blockList">
<section class="constructorSummary"><a id="constructor.summary">
<!--   -->
</a>
<h2>Constructor Summary</h2>
<div class="memberSummary">
<table>
<caption><span>Constructors</span><span class="tabEnd">&nbsp;</span></caption>
<thead>
<tr>
<th class="colFirst" scope="col">Constructor</th>
<th class="colLast" scope="col">Description</th>
</tr>
</thead>
<tbody>
<tr class="altColor">
<th class="colConstructorName" scope="row"><code><span class="memberNameLink"><a href="#%3Cinit%3E()">GrindspotController</a></span>()</code></th>
<td class="colLast">&nbsp;</td>
</tr>
</tbody>
</table>
</div>
</section>
</li>
<!-- ========== METHOD SUMMARY =========== -->
<li class="blockList">
<section class="methodSummary"><a id="method.summary">
<!--   -->
</a>
<h2>Method Summary</h2>
<div class="memberSummary">
<div role="tablist" aria-orientation="horizontal"><button role="tab" aria-selected="true" aria-controls="memberSummary_tabpanel" tabindex="0" onkeydown="switchTab(event)" id="t0" class="activeTableTab">All Methods</button><button role="tab" aria-selected="false" aria-controls="memberSummary_tabpanel" tabindex="-1" onkeydown="switchTab(event)" id="t2" class="tableTab" onclick="show(2);">Instance Methods</button><button role="tab" aria-selected="false" aria-controls="memberSummary_tabpanel" tabindex="-1" onkeydown="switchTab(event)" id="t4" class="tableTab" onclick="show(8);">Concrete Methods</button></div>
<div id="memberSummary_tabpanel" role="tabpanel">
<table aria-labelledby="t0">
<thead>
<tr>
<th class="colFirst" scope="col">Modifier and Type</th>
<th class="colSecond" scope="col">Method</th>
<th class="colLast" scope="col">Description</th>
</tr>
</thead>
<tbody>
<tr class="altColor" id="i0">
<td class="colFirst"><code>org.springframework.http.ResponseEntity&lt;<a href="../model/Grindspot.html" title="class in com.zelyvanna.bdoefficiency.model">Grindspot</a>&gt;</code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#addGrindspot(com.zelyvanna.bdoefficiency.model.Grindspot)">addGrindspot</a></span>&#8203;(<a href="../model/Grindspot.html" title="class in com.zelyvanna.bdoefficiency.model">Grindspot</a>&nbsp;grindspot)</code></th>
<td class="colLast">
<div class="block">Allows an administrator or a moderator to add a new grindspot</div>
</td>
</tr>
<tr class="rowColor" id="i1">
<td class="colFirst"><code>org.springframework.http.ResponseEntity&lt;<a href="../model/Grindspot.html" title="class in com.zelyvanna.bdoefficiency.model">Grindspot</a>&gt;</code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#deleteGrindspot(int)">deleteGrindspot</a></span>&#8203;(int&nbsp;grindspotId)</code></th>
<td class="colLast">
<div class="block">Allows an administrator or a moderator to delete a grindspot</div>
</td>
</tr>
<tr class="altColor" id="i2">
<td class="colFirst"><code>org.springframework.http.ResponseEntity&lt;java.util.List&lt;<a href="../model/GrindspotCount.html" title="class in com.zelyvanna.bdoefficiency.model">GrindspotCount</a>&gt;&gt;</code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#getAllClassesWithCounts()">getAllClassesWithCounts</a></span>()</code></th>
<td class="colLast">
<div class="block">Returns a list of Grindspots with their number of grind sessions</div>
</td>
</tr>
<tr class="rowColor" id="i3">
<td class="colFirst"><code>org.springframework.http.ResponseEntity&lt;java.util.List&lt;<a href="../model/Grindspot.html" title="class in com.zelyvanna.bdoefficiency.model">Grindspot</a>&gt;&gt;</code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#getAllGrindspots(java.lang.String)">getAllGrindspots</a></span>&#8203;(java.lang.String&nbsp;name)</code></th>
<td class="colLast">
<div class="block">Returns a list of grindspots</div>
</td>
</tr>
<tr class="altColor" id="i4">
<td class="colFirst"><code>org.springframework.http.ResponseEntity&lt;<a href="../model/Grindspot.html" title="class in com.zelyvanna.bdoefficiency.model">Grindspot</a>&gt;</code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#showGrindspot(int)">showGrindspot</a></span>&#8203;(int&nbsp;grindspotId)</code></th>
<td class="colLast">
<div class="block">Allows a User to see various informations about a Grindspot</div>
</td>
</tr>
</tbody>
</table>
</div>
</div>
<div class="inheritedList">
<h3>Methods inherited from class&nbsp;java.lang.Object</h3>
<a id="methods.inherited.from.class.java.lang.Object">
<!--   -->
</a><code>clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait</code></div>
</section>
</li>
</ul>
</section>
<section class="details">
<ul class="blockList">
<!-- ============ FIELD DETAIL =========== -->
<li class="blockList">
<section class="fieldDetails"><a id="field.detail">
<!--   -->
</a>
<h2>Field Details</h2>
<ul class="blockList">
<li class="blockList">
<section class="detail">
<h3><a id="grindspotRepository">grindspotRepository</a></h3>
<div class="memberSignature"><span class="annotations">@Autowired
</span><span class="returnType"><a href="../repository/GrindspotRepository.html" title="interface in com.zelyvanna.bdoefficiency.repository">GrindspotRepository</a></span>&nbsp;<span class="memberName">grindspotRepository</span></div>
</section>
</li>
</ul>
</section>
</li>
<!-- ========= CONSTRUCTOR DETAIL ======== -->
<li class="blockList">
<section class="constructorDetails"><a id="constructor.detail">
<!--   -->
</a>
<h2>Constructor Details</h2>
<ul class="blockList">
<li class="blockList">
<section class="detail">
<h3><a id="&lt;init&gt;()">GrindspotController</a></h3>
<div class="memberSignature"><span class="modifiers">public</span>&nbsp;<span class="memberName">GrindspotController</span>()</div>
</section>
</li>
</ul>
</section>
</li>
<!-- ============ METHOD DETAIL ========== -->
<li class="blockList">
<section class="methodDetails"><a id="method.detail">
<!--   -->
</a>
<h2>Method Details</h2>
<ul class="blockList">
<li class="blockList">
<section class="detail">
<h3><a id="getAllGrindspots(java.lang.String)">getAllGrindspots</a></h3>
<div class="memberSignature"><span class="annotations">@GetMapping("/grindspots")
@PreAuthorize("hasRole(\'USER\') or hasRole(\'MODERATOR\') or hasRole(\'ADMIN\')")
</span><span class="modifiers">public</span>&nbsp;<span class="returnType">org.springframework.http.ResponseEntity&lt;java.util.List&lt;<a href="../model/Grindspot.html" title="class in com.zelyvanna.bdoefficiency.model">Grindspot</a>&gt;&gt;</span>&nbsp;<span class="memberName">getAllGrindspots</span>&#8203;(<span class="arguments">@RequestParam(required=false)
java.lang.String&nbsp;name)</span></div>
<div class="block">Returns a list of grindspots</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>name</code> - the name of the grindspots(s) to search (if specified)</dd>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>the list of grindspots</dd>
</dl>
</section>
</li>
<li class="blockList">
<section class="detail">
<h3><a id="addGrindspot(com.zelyvanna.bdoefficiency.model.Grindspot)">addGrindspot</a></h3>
<div class="memberSignature"><span class="annotations">@PostMapping("/grindspots")
@PreAuthorize("hasRole(\'MODERATOR\') or hasRole(\'ADMIN\')")
</span><span class="modifiers">public</span>&nbsp;<span class="returnType">org.springframework.http.ResponseEntity&lt;<a href="../model/Grindspot.html" title="class in com.zelyvanna.bdoefficiency.model">Grindspot</a>&gt;</span>&nbsp;<span class="memberName">addGrindspot</span>&#8203;(<span class="arguments">@RequestBody
<a href="../model/Grindspot.html" title="class in com.zelyvanna.bdoefficiency.model">Grindspot</a>&nbsp;grindspot)</span></div>
<div class="block">Allows an administrator or a moderator to add a new grindspot</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>grindspot</code> - the grindspot recieved in parameter</dd>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>the created Grindspot with the Created HttpStatus | null with the Internal server error HttpStatus</dd>
</dl>
</section>
</li>
<li class="blockList">
<section class="detail">
<h3><a id="deleteGrindspot(int)">deleteGrindspot</a></h3>
<div class="memberSignature"><span class="annotations">@DeleteMapping("/grindspots/{grindspotId}")
@PreAuthorize("hasRole(\'MODERATOR\') or hasRole(\'ADMIN\')")
</span><span class="modifiers">public</span>&nbsp;<span class="returnType">org.springframework.http.ResponseEntity&lt;<a href="../model/Grindspot.html" title="class in com.zelyvanna.bdoefficiency.model">Grindspot</a>&gt;</span>&nbsp;<span class="memberName">deleteGrindspot</span>&#8203;(<span class="arguments">@PathVariable("grindspotId")
int&nbsp;grindspotId)</span></div>
<div class="block">Allows an administrator or a moderator to delete a grindspot</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>grindspotId</code> - the id of the grindspot to delete</dd>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>http status OK | internal server error</dd>
</dl>
</section>
</li>
<li class="blockList">
<section class="detail">
<h3><a id="showGrindspot(int)">showGrindspot</a></h3>
<div class="memberSignature"><span class="annotations">@GetMapping("/grindspots/{grindspotId}")
@PreAuthorize("hasRole(\'USER\') or hasRole(\'MODERATOR\') or hasRole(\'ADMIN\')")
</span><span class="modifiers">public</span>&nbsp;<span class="returnType">org.springframework.http.ResponseEntity&lt;<a href="../model/Grindspot.html" title="class in com.zelyvanna.bdoefficiency.model">Grindspot</a>&gt;</span>&nbsp;<span class="memberName">showGrindspot</span>&#8203;(<span class="arguments">@PathVariable("grindspotId")
int&nbsp;grindspotId)</span></div>
<div class="block">Allows a User to see various informations about a Grindspot</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>grindspotId</code> - the id of the grindspot to show</dd>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>http status OK | internal server error</dd>
</dl>
</section>
</li>
<li class="blockList">
<section class="detail">
<h3><a id="getAllClassesWithCounts()">getAllClassesWithCounts</a></h3>
<div class="memberSignature"><span class="annotations">@GetMapping("/grindspots/count")
@PreAuthorize("hasRole(\'USER\') or hasRole(\'MODERATOR\') or hasRole(\'ADMIN\')")
</span><span class="modifiers">public</span>&nbsp;<span class="returnType">org.springframework.http.ResponseEntity&lt;java.util.List&lt;<a href="../model/GrindspotCount.html" title="class in com.zelyvanna.bdoefficiency.model">GrindspotCount</a>&gt;&gt;</span>&nbsp;<span class="memberName">getAllClassesWithCounts</span>()</div>
<div class="block">Returns a list of Grindspots with their number of grind sessions</div>
<dl>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>the list of Grindspots and their number of grind sessions</dd>
</dl>
</section>
</li>
</ul>
</section>
</li>
</ul>
</section>
</div>
<!-- ========= END OF CLASS DATA ========= -->
</main>
<footer role="contentinfo">
<nav role="navigation">
<!-- ======= START OF BOTTOM NAVBAR ====== -->
<div class="bottomNav"><a id="navbar.bottom">
<!--   -->
</a>
<div class="skipNav"><a href="#skip.navbar.bottom" title="Skip navigation links">Skip navigation links</a></div>
<a id="navbar.bottom.firstrow">
<!--   -->
</a>
<ul class="navList" title="Navigation">
<li><a href="../../../../index.html">Overview</a></li>
<li><a href="package-summary.html">Package</a></li>
<li class="navBarCell1Rev">Class</li>
<li><a href="package-tree.html">Tree</a></li>
<li><a href="../../../../deprecated-list.html">Deprecated</a></li>
<li><a href="../../../../index-files/index-1.html">Index</a></li>
<li><a href="../../../../help-doc.html">Help</a></li>
</ul>
</div>
<div class="subNav">
<div>
<ul class="subNavList">
<li>Summary:&nbsp;</li>
<li>Nested&nbsp;|&nbsp;</li>
<li><a href="#field.summary">Field</a>&nbsp;|&nbsp;</li>
<li><a href="#constructor.summary">Constr</a>&nbsp;|&nbsp;</li>
<li><a href="#method.summary">Method</a></li>
</ul>
<ul class="subNavList">
<li>Detail:&nbsp;</li>
<li><a href="#field.detail">Field</a>&nbsp;|&nbsp;</li>
<li><a href="#constructor.detail">Constr</a>&nbsp;|&nbsp;</li>
<li><a href="#method.detail">Method</a></li>
</ul>
</div>
</div>
<a id="skip.navbar.bottom">
<!--   -->
</a>
<!-- ======== END OF BOTTOM NAVBAR ======= -->
</nav>
</footer>
</div>
</div>
</body>
</html>
